<?php

namespace SGalinski\SgNews\Controller\Ajax;

/***************************************************************
 *  Copyright notice
 *
 *  (c) sgalinski Internet Services (https://www.sgalinski.de)
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

use SGalinski\SgAjax\Controller\Ajax\AbstractAjaxController;
use TYPO3\CMS\Core\Database\DatabaseConnection;
use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Frontend\Page\PageRepository;

/**
 * The LikeController handles the Ajax-Actions related to the like feature
 *
 * @package SGalinski\SgNews\Controller\Ajax
 */
class LikeController extends AbstractAjaxController {

	/**
	 * This action increases the tx_sgnews_likes field of a given page ($newsPid) by one
	 *
	 * @param int $newsPid
	 * @return string
	 */
	public function addLikeAction($newsPid) {
		try {
			/** @var DatabaseConnection $database */
			$database = $GLOBALS['TYPO3_DB'];
			/** @var PageRepository $pageRepository */
			$pageRepository = GeneralUtility::makeInstance('TYPO3\\CMS\\Frontend\\Page\\PageRepository');

			$database->sql_query('UPDATE pages SET tx_sgnews_likes = tx_sgnews_likes ' .  '+ 1 WHERE uid=' . (int) $newsPid .
				$pageRepository->enableFields('pages'));
		} catch (\Exception $exception) {
			$this->returnData(['success' => false]);
		}

		$this->returnData(['success' => true]);
	}
}
